"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MToolbarFilePopup = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const commands_1 = require("../../../markup/commands");
const ToolbarFilePopup_1 = require("../custom/ToolbarFilePopup");
const context_1 = require("./context");
const MToolbarFilePopup = ({ focus, onClick, hide, anchorRef, editor, className, }) => {
    const { uploadHandler } = (0, context_1.useMarkupToolbarContext)();
    return (react_1.default.createElement(ToolbarFilePopup_1.ToolbarFilePopup, { hide: hide, focus: focus, onClick: onClick, anchorRef: anchorRef, className: className, onSubmit: (fileParams) => (0, commands_1.insertFiles)([fileParams])(editor.cm), uploadHandler: uploadHandler, onSuccessUpload: (res) => {
            (0, commands_1.insertFiles)(res.success.map(({ result, file }) => {
                var _a, _b;
                return ({
                    src: result.url,
                    name: (_a = result.name) !== null && _a !== void 0 ? _a : file.name,
                    type: (_b = result.type) !== null && _b !== void 0 ? _b : file.type,
                });
            }))(editor.cm);
        } }));
};
exports.MToolbarFilePopup = MToolbarFilePopup;
