"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseLevel = exports.isUnfoldedHeading = exports.isFoldedHeading = exports.isFoldingHeading = exports.isHeading = exports.hasFolding = exports.insideHeading = exports.headingType = void 0;
const const_1 = require("./const");
var HeadingSpecs_1 = require("../../markdown/Heading/HeadingSpecs");
Object.defineProperty(exports, "headingType", { enumerable: true, get: function () { return HeadingSpecs_1.headingType; } });
const insideHeading = ({ $anchor, $head }) => $anchor.sameParent($head) && isHeading($head.parent);
exports.insideHeading = insideHeading;
const hasFolding = (sel) => (0, exports.insideHeading)(sel) && sel.$head.parent.attrs[const_1.YfmHeadingAttr.Folding] !== null;
exports.hasFolding = hasFolding;
function isHeading(node) {
    return node.type.name === const_1.headingNodeName;
}
exports.isHeading = isHeading;
function isFoldingHeading(node) {
    return isHeading(node) && typeof node.attrs[const_1.YfmHeadingAttr.Folding] === 'boolean';
}
exports.isFoldingHeading = isFoldingHeading;
function isFoldedHeading(node) {
    return isHeading(node) && node.attrs[const_1.YfmHeadingAttr.Folding] === true;
}
exports.isFoldedHeading = isFoldedHeading;
function isUnfoldedHeading(node) {
    return isHeading(node) && node.attrs[const_1.YfmHeadingAttr.Folding] === false;
}
exports.isUnfoldedHeading = isUnfoldedHeading;
function parseLevel(node) {
    return Number.parseInt(node.attrs[const_1.YfmHeadingAttr.Level], 10);
}
exports.parseLevel = parseLevel;
