"use strict";
var _GapCursorSelection__$pos;
Object.defineProperty(exports, "__esModule", { value: true });
exports.GapCursorSelection = exports.isGapCursorSelection = void 0;
const tslib_1 = require("tslib");
const prosemirror_state_1 = require("prosemirror-state");
function isGapCursorSelection(selection) {
    return selection instanceof GapCursorSelection;
}
exports.isGapCursorSelection = isGapCursorSelection;
// @ts-expect-error // TODO: implements toJSON
class GapCursorSelection extends prosemirror_state_1.Selection {
    constructor($pos, params) {
        super($pos, $pos);
        _GapCursorSelection__$pos.set(this, void 0);
        this.selectionName = 'GapCursorSelection';
        tslib_1.__classPrivateFieldSet(this, _GapCursorSelection__$pos, $pos, "f");
        this.meta = params === null || params === void 0 ? void 0 : params.meta;
    }
    get $pos() {
        return tslib_1.__classPrivateFieldGet(this, _GapCursorSelection__$pos, "f");
    }
    get pos() {
        return tslib_1.__classPrivateFieldGet(this, _GapCursorSelection__$pos, "f").pos;
    }
    eq(other) {
        return (isGapCursorSelection(other) &&
            this.pos === other.pos &&
            this.$pos.doc.eq(other.$pos.doc));
    }
    map(doc, mapping) {
        const $pos = doc.resolve(mapping.map(this.head));
        return prosemirror_state_1.Selection.near($pos);
    }
}
exports.GapCursorSelection = GapCursorSelection;
_GapCursorSelection__$pos = new WeakMap();
