"use strict";
var _LinkWidgetDescriptor_domElem, _LinkWidgetDescriptor_view, _LinkWidgetDescriptor_getPos;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LinkWidgetDescriptor = exports.addPlaceholder = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const WidgetDecoration_1 = require("../../../behavior/WidgetDecoration");
const ReactWidgetDescriptor_1 = require("../../../behavior/WidgetDecoration/ReactWidgetDescriptor");
const index_1 = require("../../index");
const widget_1 = require("./widget");
const addPlaceholder = (tr, deps) => {
    return new LinkWidgetDescriptor(tr.selection.from, deps).applyTo(tr);
};
exports.addPlaceholder = addPlaceholder;
class LinkWidgetDescriptor extends ReactWidgetDescriptor_1.ReactWidgetDescriptor {
    constructor(initPos, deps) {
        super(initPos, 'link-empty');
        _LinkWidgetDescriptor_domElem.set(this, void 0);
        _LinkWidgetDescriptor_view.set(this, void 0);
        _LinkWidgetDescriptor_getPos.set(this, void 0);
        this.onCancel = () => {
            if (!tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f"))
                return;
            tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").dispatch((0, WidgetDecoration_1.removeDecoration)(tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").state.tr, this.id));
            tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").focus();
        };
        this.onSubmit = (params) => {
            const normalizeResult = this.normalizeUrl(params.url);
            if (!normalizeResult || !tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f") || !tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_getPos, "f"))
                return;
            const { url } = normalizeResult;
            const text = params.text.trim() || normalizeResult.text;
            const from = tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_getPos, "f").call(this);
            const to = from + text.length;
            let tr = tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").state.tr;
            tr = tr.insertText(text, from);
            tr = tr.addMark(from, to, (0, index_1.linkType)(tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").state.schema).create({ [index_1.LinkAttr.Href]: url }));
            tr = (0, WidgetDecoration_1.removeDecoration)(tr, this.id);
            tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").dispatch(tr);
            tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_view, "f").focus();
        };
        tslib_1.__classPrivateFieldSet(this, _LinkWidgetDescriptor_domElem, document.createElement('span'), "f");
        this.normalizeUrl = (0, index_1.normalizeUrlFactory)(deps);
    }
    getDomElem() {
        return tslib_1.__classPrivateFieldGet(this, _LinkWidgetDescriptor_domElem, "f");
    }
    renderReactElement(view, getPos) {
        tslib_1.__classPrivateFieldSet(this, _LinkWidgetDescriptor_view, view, "f");
        tslib_1.__classPrivateFieldSet(this, _LinkWidgetDescriptor_getPos, getPos, "f");
        return react_1.default.createElement(widget_1.LinkPlaceholderWidget, { onCancel: this.onCancel, onSubmit: this.onSubmit });
    }
}
exports.LinkWidgetDescriptor = LinkWidgetDescriptor;
_LinkWidgetDescriptor_domElem = new WeakMap(), _LinkWidgetDescriptor_view = new WeakMap(), _LinkWidgetDescriptor_getPos = new WeakMap();
