"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListsSpecs = exports.olType = exports.blType = exports.liType = exports.ListNode = exports.ListsAttr = void 0;
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const parser_1 = require("./parser");
const schema_2 = require("./schema");
const serializer_1 = require("./serializer");
var const_2 = require("./const");
Object.defineProperty(exports, "ListsAttr", { enumerable: true, get: function () { return const_2.ListsAttr; } });
Object.defineProperty(exports, "ListNode", { enumerable: true, get: function () { return const_2.ListNode; } });
exports.liType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.ListItem);
exports.blType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.BulletList);
exports.olType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.OrderedList);
const ListsSpecs = (builder) => {
    builder
        .addNode(const_1.ListNode.ListItem, () => ({
        spec: schema_2.schemaSpecs[const_1.ListNode.ListItem],
        toMd: serializer_1.serializerTokens[const_1.ListNode.ListItem],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.ListNode.ListItem] },
    }))
        .addNode(const_1.ListNode.BulletList, () => ({
        spec: schema_2.schemaSpecs[const_1.ListNode.BulletList],
        toMd: serializer_1.serializerTokens[const_1.ListNode.BulletList],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.ListNode.BulletList] },
    }))
        .addNode(const_1.ListNode.OrderedList, () => ({
        spec: schema_2.schemaSpecs[const_1.ListNode.OrderedList],
        toMd: serializer_1.serializerTokens[const_1.ListNode.OrderedList],
        fromMd: { tokenSpec: parser_1.parserTokens[const_1.ListNode.OrderedList] },
    }));
};
exports.ListsSpecs = ListsSpecs;
