"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmFileSpecs = exports.fileType = exports.yfmFileNodeName = void 0;
const tslib_1 = require("tslib");
const file_1 = tslib_1.__importDefault(require("@diplodoc/transform/lib/plugins/file"));
const const_1 = require("@diplodoc/transform/lib/plugins/file/const");
const schema_1 = require("../../../../utils/schema");
const const_2 = require("./const");
var const_3 = require("./const");
Object.defineProperty(exports, "yfmFileNodeName", { enumerable: true, get: function () { return const_3.yfmFileNodeName; } });
exports.fileType = (0, schema_1.nodeTypeFactory)(const_2.yfmFileNodeName);
const YfmFileSpecs = (builder) => {
    builder.configureMd((md) => md.use(file_1.default));
    builder.addNode(const_2.yfmFileNodeName, () => ({
        spec: {
            group: 'inline',
            inline: true,
            attrs: const_2.fileNodeAttrsSpec,
            parseDOM: [
                {
                    tag: `a[class="${const_1.FileClassName.Link}"]`,
                    getAttrs(p) {
                        const elem = p;
                        const attrs = {};
                        for (const name of const_2.KNOWN_ATTRS) {
                            const value = elem.getAttribute(name);
                            if (value) {
                                attrs[name] = value;
                            }
                        }
                        return attrs;
                    },
                    priority: 101,
                },
            ],
            toDOM(node) {
                const a = document.createElement('a');
                a.contentEditable = 'false';
                a.classList.add(const_1.FileClassName.Link);
                for (const [key, value] of Object.entries(node.attrs)) {
                    if (value)
                        a.setAttribute(key, value);
                }
                const span = document.createElement('span');
                span.classList.add(const_1.FileClassName.Icon);
                a.appendChild(span);
                a.append(node.attrs[const_1.LinkHtmlAttr.Download]);
                return a;
            },
        },
        fromMd: {
            tokenName: const_2.yfmFileNodeName,
            tokenSpec: {
                name: const_2.yfmFileNodeName,
                type: 'node',
                getAttrs: (tok) => {
                    var _a;
                    return Object.fromEntries((_a = tok.attrs) !== null && _a !== void 0 ? _a : []);
                },
            },
        },
        toMd: (state, node) => {
            const attrsStr = Object.entries(node.attrs)
                .reduce((arr, [key, value]) => {
                if (value) {
                    if (key in const_2.LINK_TO_FILE_ATTRS_MAP) {
                        key = const_2.LINK_TO_FILE_ATTRS_MAP[key];
                    }
                    arr.push(`${key}="${value.replace(/"/g, '')}"`);
                }
                return arr;
            }, [])
                .join(' ');
            state.write(`${const_1.PREFIX}${attrsStr} %}`);
        },
    }));
};
exports.YfmFileSpecs = YfmFileSpecs;
