"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createYfmTabs = exports.createYfmTabsCommand = void 0;
const utils_1 = require("@diplodoc/transform/lib/plugins/utils");
const BaseSchema_1 = require("../../base/BaseSchema");
const const_1 = require("./YfmTabsSpecs/const");
const const_2 = require("./const");
const _1 = require(".");
const createYfmTabsCommand = (state, dispatch) => {
    if (dispatch) {
        const { schema } = state;
        const tabId = (0, utils_1.generateID)();
        const panelId = (0, utils_1.generateID)();
        const yfmTabsList = (0, _1.tabsListType)(schema);
        const yfmTabs = (0, _1.tabsType)(schema);
        const yfmTabPanel = (0, _1.tabPanelType)(state.schema).create({
            [const_1.TabPanelAttrs.ariaLabelledby]: tabId,
            [const_1.TabPanelAttrs.id]: panelId,
            [const_1.TabPanelAttrs.class]: const_2.tabPanelActiveClassname,
        }, (0, BaseSchema_1.pType)(state.schema).createAndFill());
        const yfmTab = (0, _1.tabType)(state.schema).create({
            [const_1.TabAttrs.id]: tabId,
            [const_1.TabAttrs.class]: const_2.tabActiveClassname,
            [const_1.TabAttrs.ariaControls]: panelId,
            [const_1.TabAttrs.dataDiplodocIsActive]: 'true',
            [const_1.TabAttrs.dataDiplodocid]: tabId,
            [const_1.TabAttrs.dataDiplodocKey]: tabId,
        });
        const tabs = yfmTabs.create({ [const_1.TabsAttrs.dataDiplodocGroup]: (0, utils_1.generateID)() }, [
            yfmTabsList.create(null, [yfmTab]),
            yfmTabPanel,
        ]);
        dispatch(state.tr.replaceSelectionWith(tabs).scrollIntoView());
    }
    return true;
};
exports.createYfmTabsCommand = createYfmTabsCommand;
exports.createYfmTabs = {
    isEnable: exports.createYfmTabsCommand,
    run: exports.createYfmTabsCommand,
};
