"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadLabel = exports.renderWidget = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const icons_2 = require("../../../bundle/config/icons");
const classname_1 = require("../../../classname");
function renderWidget(container, props) {
    return (react_1.default.createElement(uikit_1.Portal, { container: container },
        react_1.default.createElement(UploadLabel, Object.assign({}, props))));
}
exports.renderWidget = renderWidget;
const cnLabel = (0, classname_1.cn)('upload-label');
function UploadLabel({ fileName, fileType, status, errorText, onReUploadClick, }) {
    const icon = fileType === 'image' ? icons_2.icons.image : icons_2.icons.file;
    if (status === 'uploading') {
        return (react_1.default.createElement(uikit_1.Label, { size: "xs", theme: "info", icon: react_1.default.createElement(uikit_1.Icon, Object.assign({}, icon)), className: cnLabel({ status }) },
            react_1.default.createElement("div", { className: cnLabel('content') },
                react_1.default.createElement("span", { title: fileName, className: cnLabel('filename') }, fileName),
                react_1.default.createElement(uikit_1.Spin, { size: "xs" }))));
    }
    if (status === 'success') {
        return (react_1.default.createElement(uikit_1.Label, { size: "xs", theme: "success", icon: react_1.default.createElement(uikit_1.Icon, Object.assign({}, icon)), className: cnLabel({ status }) },
            react_1.default.createElement("div", { className: cnLabel('content') },
                react_1.default.createElement("span", { title: fileName, className: cnLabel('filename') }, fileName))));
    }
    if (status === 'error') {
        return (react_1.default.createElement(uikit_1.Tooltip, { content: errorText },
            react_1.default.createElement(uikit_1.Label, { size: "xs", interactive: true, theme: "danger", icon: react_1.default.createElement(uikit_1.Icon, Object.assign({}, icon)), onClick: onReUploadClick, className: cnLabel({ status }) },
                react_1.default.createElement("div", { className: cnLabel('content') },
                    react_1.default.createElement("span", { className: cnLabel('filename') }, fileName),
                    react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowsRotateRight, size: 16 })))));
    }
    return null;
}
exports.UploadLabel = UploadLabel;
