import { EditorView, ViewPlugin, ViewUpdate } from '@codemirror/view';
import type { MarkdownEditorMode } from '../../../bundle';
import type { EventMap } from '../../../bundle/Editor';
import type { RendererItem } from '../../../extensions';
import { Receiver } from '../../../utils';
interface SearchQueryParams {
    search: string;
    caseSensitive?: boolean;
    literal?: boolean;
    regexp?: boolean;
    replace?: string;
    valid?: boolean;
    wholeWord?: boolean;
}
export interface SearchPanelPluginParams {
    anchorSelector: string;
    inputDelay?: number;
    receiver?: Receiver<EventMap>;
}
export declare const SearchPanelPlugin: (params: SearchPanelPluginParams) => ViewPlugin<{
    readonly view: EditorView;
    readonly params: SearchPanelPluginParams;
    anchor: HTMLElement | null;
    renderer: RendererItem | null;
    searchQuery: SearchQueryParams;
    receiver: Receiver<EventMap> | undefined;
    setViewSearchWithDelay: (config: Partial<SearchQueryParams>) => void;
    update(update: ViewUpdate): void;
    destroy(): void;
    setViewSearch(config: Partial<SearchQueryParams>): void;
    handleEditorModeChange({ mode }: {
        mode: MarkdownEditorMode;
    }): void;
    handleChange(search: string): void;
    handleClose(): void;
    handleSearchNext(): void;
    handleSearchPrev(): void;
    handleSearchConfigChange({ isCaseSensitive, isWholeWord, }: {
        isCaseSensitive?: boolean | undefined;
        isWholeWord?: boolean | undefined;
    }): void;
}>;
export {};
