"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const react_utils_1 = require("../../react-utils");
const TooltipButton = ({ domRef, buttonTitle = 'Settings', items, onUpdate, withSearch, onOutsideClick, }) => {
    var _a;
    const [width, setWidth] = (0, react_1.useState)(0);
    const [open, , , toggleOpen] = (0, react_utils_1.useBooleanState)(false);
    const ref = (0, react_1.useRef)(null);
    (0, react_1.useLayoutEffect)(() => {
        var _a, _b;
        if ((_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth) {
            setWidth((_b = ref.current) === null || _b === void 0 ? void 0 : _b.clientWidth);
        }
    }, [(_a = ref.current) === null || _a === void 0 ? void 0 : _a.clientWidth, buttonTitle]);
    return (react_1.default.createElement(uikit_1.Popup, { open: true, keepMounted: false, hasArrow: false, anchorRef: { current: domRef }, placement: 'right-start', offset: [10, -(width + 10)], onOutsideClick: onOutsideClick, modifiers: [
            {
                name: 'preventOverflow',
                enabled: false,
            },
        ] },
        react_1.default.createElement(uikit_1.Select, { onOpenChange: toggleOpen, renderControl: () => (react_1.default.createElement(uikit_1.Button, { ref: ref, view: 'flat' },
                buttonTitle,
                react_1.default.createElement(uikit_1.ArrowToggle, { direction: open ? 'top' : 'bottom' }))), options: items, onUpdate: (v) => onUpdate(v[0]), filterable: withSearch })));
};
exports.TooltipButton = TooltipButton;
