import type { Extension, ExtensionAuto } from '../core';
import { BlockquoteOptions, BoldOptions, BreaksOptions, CodeBlockOptions, CodeOptions, HeadingOptions, ItalicOptions, LinkOptions, ListsOptions } from '../extensions/markdown';
import { ZeroPresetOptions } from './zero';
export declare type CommonMarkPresetOptions = ZeroPresetOptions & {
    bold?: BoldOptions;
    code?: CodeOptions;
    link?: LinkOptions;
    lists?: ListsOptions;
    italic?: ItalicOptions;
    breaks?: BreaksOptions;
    image?: false | Extension;
    codeBlock?: CodeBlockOptions;
    blockquote?: BlockquoteOptions;
    heading?: false | Extension | HeadingOptions;
};
export declare const CommonMarkPreset: ExtensionAuto<CommonMarkPresetOptions>;
