"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useToaster = exports.ToasterContext = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
exports.ToasterContext = react_1.default.createContext(null);
exports.ToasterContext.displayName = 'YEToasterContext';
function useToaster() {
    const toaster = react_1.default.useContext(exports.ToasterContext);
    if (!toaster) {
        throw new Error('YEToaster: `useToaster` hook is used out of context');
    }
    return react_1.default.useMemo(() => toaster, [toaster]);
}
exports.useToaster = useToaster;
