import React from 'react';
import { IconProps } from '@gravity-ui/uikit';
import { Action, ActionStorage } from '../../core';
import { ToolbarBaseProps, ToolbarIconData } from '../../toolbar';
import './ToolbarButtonWithPopupMenu.css';
export declare type MenuItem = {
    id: string;
    action: Action;
    icon: IconProps['data'];
    text: string;
    iconSize?: IconProps['size'];
    iconClassname?: string;
    group?: string;
    ignoreActive?: boolean;
};
export declare type ToolbarButtonWithPopupMenuProps = Omit<ToolbarBaseProps<ActionStorage> & {
    icon: ToolbarIconData;
    title: string | (() => string);
    menuItems: MenuItem[];
}, 'editor'>;
export declare const ToolbarButtonWithPopupMenu: React.FC<ToolbarButtonWithPopupMenuProps>;
