import type { FC } from 'react';
import type { IconRefugeProps } from './IconRefuge.types';
import './IconRefuge.css';
/**
 * Creates a div wrapper above the icon, which sets the min-width and min-height
 * equal to its refugeSize prop, puts the original icon in the middle and
 * proxies the rest of the propses to it.
 *
 * The component is made in order to add margins to icons that have
 * margins are indented, but their svg exactly wrap around the edges of the image
 *
 * It seems that all icons will be square, if not, then you can simply add
 * refugeWidth and refugeHeight
 */
export declare const IconRefuge: FC<IconRefugeProps>;
