import { PopupProps } from '@gravity-ui/uikit';
import { EditorState } from 'prosemirror-state';
import { EditorView } from 'prosemirror-view';
import { ActionStorage } from '../../../core';
import { ToolbarButtonPopupData, ToolbarGroupItemData, ToolbarSingleItemData } from '../../../toolbar';
export declare type ContextGroupItemData = (ToolbarGroupItemData<ActionStorage> & {
    condition?: (state: EditorState) => void;
}) | ((ToolbarSingleItemData<ActionStorage> | ToolbarButtonPopupData<ActionStorage>) & {
    condition?: 'enabled';
});
export declare type ContextGroupData = ContextGroupItemData[];
export declare type ContextConfig = ContextGroupData[];
export declare class TooltipView {
    #private;
    private actions;
    private menuConfig;
    private view;
    private baseProps;
    private _tooltipRenderItem;
    constructor(actions: ActionStorage, menuConfig: ContextConfig);
    get isTooltipOpen(): boolean;
    show(view: EditorView, popupProps?: PopupProps): void;
    hide(view: EditorView): void;
    destroy(): void;
    private getSelectionTooltipProps;
    private getFilteredConfig;
    private renderPopup;
    private get tooltipRenderItem();
    private calcPosition;
    private get popupTextOffset();
}
