import { addColumnAfter, addRowAfter as addRowAfterOrig, removeCurrentColumn, removeCurrentRow, } from '../../../../table-utils';
import { defineActions } from '../../../../utils/actions';
import { findParentBody } from '../helpers';
import { setCellCenterAlign, setCellLeftAlign, setCellRightAlign } from './cellAlign';
const addRowAfter = (state, dispatch, view) => {
    if (!findParentBody(state)) {
        return false; // TODO: process when cursor is inside thead
    }
    return addRowAfterOrig(state, dispatch, view);
};
const addRow = {
    isEnable: addRowAfter,
    run: addRowAfter,
};
const deleteRow = {
    isEnable: removeCurrentRow,
    run: removeCurrentRow,
};
const addColumn = {
    isEnable: addColumnAfter,
    run: addColumnAfter,
};
const deleteColumn = {
    isEnable: removeCurrentColumn,
    run: removeCurrentColumn,
};
export const innerActions = defineActions({
    setCellLeftAlign,
    setCellCenterAlign,
    setCellRightAlign,
    addRow,
    deleteRow,
    addColumn,
    deleteColumn,
});
