import React from 'react';
import './SearchPopup.css';
interface SearchConfig {
    isCaseSensitive: boolean;
    isWholeWord: boolean;
}
interface SearchCardProps {
    onSearchKeyDown?: (query: string) => void;
    onChange?: (query: string) => void;
    onClose?: (query: string) => void;
    onSearchPrev?: (query: string) => void;
    onSearchNext?: (query: string) => void;
    onConfigChange?: (config: SearchConfig) => void;
}
export declare const SearchCard: React.FC<SearchCardProps>;
export interface SearchPopupProps {
    anchor: HTMLElement;
    onChange: (query: string) => void;
    onClose: () => void;
    onSearchNext: () => void;
    onSearchPrev: () => void;
    onConfigChange: (config: SearchConfig) => void;
    open: boolean;
}
export declare const SearchPopup: React.FC<SearchPopupProps>;
interface SearchPopupWithRefProps extends Omit<SearchPopupProps, 'anchor'> {
    anchor: HTMLElement | null;
}
export declare function renderSearchPopup({ anchor, open, onClose, ...props }: SearchPopupWithRefProps): JSX.Element;
export {};
