import type { ExtensionAuto } from '../core';
import { DeflistSpecsOptions } from '../extensions/specs';
import { CheckboxSpecsOptions, ImgSizeSpecsOptions, VideoSpecsOptions, YfmConfigsSpecsOptions, YfmCutSpecsOptions, YfmHeadingSpecsOptions, YfmNoteSpecsOptions, YfmTableSpecsOptions, YfmTabsSpecsOptions } from '../extensions/yfm/specs';
import { DefaultSpecsPresetOptions } from './default-specs';
export declare type YfmSpecsPresetOptions = Omit<DefaultSpecsPresetOptions, 'heading' | 'image'> & {
    checkbox?: CheckboxSpecsOptions;
    deflist?: DeflistSpecsOptions;
    video?: VideoSpecsOptions;
    imgSize?: ImgSizeSpecsOptions;
    yfmConfigs?: YfmConfigsSpecsOptions;
    yfmCut?: YfmCutSpecsOptions;
    yfmNote?: YfmNoteSpecsOptions;
    yfmTable?: YfmTableSpecsOptions;
    yfmTabs?: YfmTabsSpecsOptions;
    yfmHeading?: YfmHeadingSpecsOptions;
};
export declare const YfmSpecsPreset: ExtensionAuto<YfmSpecsPresetOptions>;
