import type { ExtensionAuto } from '../core';
import { DeflistOptions, UnderlineOptions } from '../extensions/markdown';
import { CheckboxOptions, ImgSizeOptions, VideoOptions, YfmConfigsOptions, YfmCutOptions, YfmFileOptions, YfmHeadingOptions, YfmNoteOptions, YfmTableOptions } from '../extensions/yfm';
import { DefaultPresetOptions } from './default';
export declare type YfmPresetOptions = Omit<DefaultPresetOptions, 'heading' | 'image'> & {
    checkbox?: CheckboxOptions;
    deflist?: DeflistOptions;
    underline?: UnderlineOptions;
    imgSize?: ImgSizeOptions;
    video?: VideoOptions;
    yfmConfigs?: YfmConfigsOptions;
    yfmCut?: YfmCutOptions;
    yfmFile?: YfmFileOptions;
    yfmHeading?: YfmHeadingOptions;
    yfmNote?: YfmNoteOptions;
    yfmTable?: YfmTableOptions;
};
export declare const YfmPreset: ExtensionAuto<YfmPresetOptions>;
