import React from 'react';
import type { ToolbarBaseProps, ToolbarItemData } from './types';
import './ToolbarButton.css';
export declare type ToolbarButtonProps<E> = ToolbarBaseProps<E> & ToolbarItemData<E>;
export declare type ToolbarButtonViewProps = Pick<ToolbarItemData<unknown>, 'icon' | 'title' | 'hint' | 'hotkey' | 'disabledPopoverVisible' | 'hintWhenDisabled'> & {
    active: boolean;
    enabled: boolean;
    onClick: () => void;
    className?: string;
};
export declare const ToolbarButtonView: React.ForwardRefExoticComponent<Pick<ToolbarItemData<unknown>, "title" | "icon" | "hint" | "hotkey" | "disabledPopoverVisible" | "hintWhenDisabled"> & {
    active: boolean;
    enabled: boolean;
    onClick: () => void;
    className?: string | undefined;
} & React.RefAttributes<HTMLElement>>;
export declare function ToolbarButton<E>(props: ToolbarButtonProps<E>): JSX.Element;
