import React, { forwardRef, useEffect } from 'react';
import { useDiplodocEmbeddedContentController } from '@diplodoc/html-extension/react';
import { useYfmHtmlBlockRuntime } from './useYfmHtmlBlockRuntime';
export function withYfmHtmlBlock(opts) {
    return (Component) => forwardRef(function WithYfmHtml(props, ref) {
        const { meta, html, yfmHtmlBlockConfig } = props;
        useYfmHtmlBlockRuntime(meta, opts.runtime);
        const yfmHtmlBlock = useDiplodocEmbeddedContentController();
        useEffect(() => {
            if (yfmHtmlBlock) {
                if (yfmHtmlBlockConfig) {
                    yfmHtmlBlock.setConfig(yfmHtmlBlockConfig);
                }
                yfmHtmlBlock.initialize();
            }
        }, [yfmHtmlBlock, html, yfmHtmlBlockConfig]);
        return React.createElement(Component, Object.assign({}, props, { ref: ref }));
    });
}
